<html lang="en" xmns:th="http://www.thymeleaf.org"
		xmlns:layout="http://ultraq.net.nz/thymeleaf/layout"
		layout:decorate="~{fragments/layout}">
<head>

	<title>Page Product API</title>
</head>
<body>
	<div layout:fragment="content">
		<h1>Product Page</h1>
		<br>
		<div class="container">
			<div class="row">
			<div class="col-sm">
			
			</div>
			<div class="col-sm">
				<table>
			    	<tr>
				    	<td>
					    	<button type="button" class="btn btn-primary" onclick="openModal()" >
							  Create New</button>
				    	</td>
				    	<td style='width:308px;'></td>
				    	<td><input onkeyup="searchProduct()" id="keySearch" type = 'text' placeholder="Search" value = '' ></td>
			    	</tr>
			    	</table><br>
				<div id="isiData"></div>
			</div>
			<div class="col-sm">
			
			</div>
		</div>
		<script>
			$(function(){
				getAllProduct();
				
				
			})
			
			function searchProduct(){
				var key = $('#keySearch').val();
				
				if(key != 0 ){
					$.ajax({
						url: '/api/product/search/'+key+'',
						type: 'get',
						contentType: 'application/json',
						success: function (data) {
							var str = "<table border = '2' class='table' style='text-align:center;'>"
								str += "<thaed>"
								str += "<tr>"
								str += "<th>Category/Variant</th>"
								str += "<th>Initial</th>"
								str += "<th>Name</th>"
								str += "<th>Description</th>"
								str += "<th>Price</th>"
								str += "<th>Stok</th>"
								str += "<th>Active</th>"
								str += "<th colspan='2' >Action</th>"
								str += "</tr>"
								str += "</thead>"
								str += "<tbody>"
								for (var i = 0; i < data.length; i++){
									str += "<tr>"
									str += "<td>"+data[i].variant.category.categoryName+" /<br>"+data[i].variant.variantName+"</td>"
									str += "<td>"+data[i].productInitial+"</td>"
									str += "<td>"+data[i].productName+"</td>"
									str += "<td>"+data[i].productDescription+"</td>"
									str += "<td>"+data[i].productPrice+"</td>"
									str += "<td>"+data[i].productStok+"</td>"
									str += "<td><input type='checkbox' name='isactive' checked disabled></td>"
									str += "<td><button onclick='modalEdit("+data[i].id+")' >Edit</button></td>"
									str += "<td><button  onclick='openModalDelete("+data[i].id+")' >Hapus</button></td>"
									str += "</tr>"
								}
								
								str += "</tbody>"
								str += "</table>"
								$('#isiData').html(str)
						}
					})
				}else{
					getAllProduct() 
				}
			}
			
			function getAllProduct(){
				$.ajax({
					url: '/api/product',
					type: 'get',
					contenType: 'aplication/json',
					success: function (data){
						var str = "<table border = '2' class='table' style='text-align:center;'>"
							str += "<thaed>"
							str += "<tr>"
							str += "<th>Category/Variant</th>"
							str += "<th>Initial</th>"
							str += "<th>Name</th>"
							str += "<th>Description</th>"
							str += "<th>Price</th>"
							str += "<th>Stok</th>"
							str += "<th>Active</th>"
							str += "<th colspan='2' >Action</th>"
							str += "</tr>"
							str += "</thead>"
							str += "<tbody>"
							for (var i = 0; i < data.length; i++){
								str += "<tr>"
								str += "<td>"+data[i].variant.category.categoryName+" /<br>"+data[i].variant.variantName+"</td>"
								str += "<td>"+data[i].productInitial+"</td>"
								str += "<td>"+data[i].productName+"</td>"
								str += "<td>"+data[i].productDescription+"</td>"
								str += "<td>"+data[i].productPrice+"</td>"
								str += "<td>"+data[i].productStok+"</td>"
								str += "<td><input type='checkbox' name='isactive' checked disabled></td>"
								str += "<td><button onclick='modalEdit("+data[i].id+")' >Edit</button></td>"
								str += "<td><button  onclick='openModalDelete("+data[i].id+")' >Hapus</button></td>"
								str += "</tr>"
							}
							
							str += "</tbody>"
							str += "</table>"
							$('#isiData').html(str)
					}
				})
			}
			
			function getVariant(idCat,idVar){
				$.ajax({
						url: '/api/product/getvar/'+idCat+'',
						type: 'get',
						contentType: 'application/json',
						success: function (data2) {
							$('#idVariant').empty();
							for(var i = 0 ; i < data2.length; i++){
								$('#idVariant').append($('<option value='+data2[i].id+'>'+data2[i].variantName+'</option>'))
							}
							if(idVar!=0){
								$('#idVariant').val(idVar);
							}
						}
					})
			}
			
			function openModal(){
				$.ajax({
					url: '/api/category',
					type: 'get',
					contentType: 'aplication/json',
					success: function (data) {
						var str = "<form'>"
							str += "<input id='productId' type='hidden' value=0>"
							str += "<div class = 'form-group'>"
							str += "<label>Category</label>"
							str += "<select class = 'form-control' id = 'idCategory'>"
							str += "<option value='0'>-Pilih-</option>"
							for (var i = 0; i < data.length; i++) {
								str += "<option value='" + data[i].id + "'>" + data[i].categoryName + "</option>"
							}
							str += "</select>"
							str += "<div class = 'form-group' id>"
							str += "<label>Variant</label>"
							str += "<select class = 'form-control' id = 'idVariant'>"
							str += "<option value='0'>-Pilih-</option>"
							str += "</select>"
							str += "</div>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Initial Product</label>"
							str += "<input class = 'form-control' type='text' id = 'productInitial'>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Name Product</label>"
							str += "<input class = 'form-control' type='text' id = 'productName'>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Description</label>"
							str += "<input class = 'form-control' type='text' id = 'productDesc'>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Price</label>"
							str += "<input class = 'form-control' type='number' id = 'productPrice'>"
							str += "</div>"
							str += "<div class = 'form-group'>"
							str += "<label>Stok</label>"
							str += "<input class = 'form-control' type='number' id = 'productStok'>"
							str += "</div>"
							str += "<div class = 'form-group form-check'>"
							str += "<input type = 'checkbox' class='form-check-input' id='isActive'>"
							str += "<label>Active</label>"
							str += "</div>"
							str += "</form>"
						
						$('.modal-title').html('New Product')
						$('.modal-body').html(str)
						$('#modal').modal('show')
						$('#btn-save').off('click').on('click',saveProduct).html('Create Data')
						
						$('#idCategory').on("change",function(){
							
							var id = $('#idCategory').val();
							getVariant(id,0);
						})
					}
				})
			}
			
			function saveProduct(){
				var id = $('#productId').val()
				var idVar = $('#idVariant').val()
				var initial = $('#productInitial').val()
				var name = $('#productName').val()
				var des = $('#productDesc').val()
				var price = $('#productPrice').val()
				var stok = $('#productStok').val()
				var active = $('#isActive')[0].checked
				var link = ''
				var type = ''
				
				if(id==0){
					link = '/api/product/add'
					type = 'post'
				}else{
					link = '/api/edit/product/'+id+''
					type = 'put'
				}
				
				var datainput = '{'
					datainput += '"productInitial":"'+initial+'",'
					datainput += '"productName":"'+name+'",'
					datainput += '"productDescription":"'+des+'",'
					datainput += '"productPrice":"'+price+'",'
					datainput += '"productStok":"'+stok+'",'
					datainput += '"isActive":"'+active+'",'
					datainput += '"variantId":'+idVar+''
					datainput +='}'
					
				$.ajax({
					url: link,
					type: type,
					contentType:'application/json',
					data: datainput,
					success: function(){
						$('#modal').modal('toggle')
						getAllProduct()
					}
				})
			}
			
			function modalEdit(id){
				openModal();
				$.ajax({
					url: '/api/product/'+id+'',
					type: 'get',
					contentType: 'application/json',
					success: function(data){
						$('#idCategory').val(data.variant.category.id)
						getVariant(data.variant.category.id,data.variant.id)
						$('#productId').val(data.id)
						$('#productInitial').val(data.productInitial)
						$('#productName').val(data.productName)
						$('#productDesc').val(data.productDescription)
						$('#productPrice').val(data.productPrice)
						$('#productStok').val(data.productStok)
						$('#isActive').prop("checked",true)
						
						$('#btn-save').html('Update Data')
					}
				})
			}
			
			function openModalDelete(id) {
				$.ajax({
					url: '/api/product/'+id+'',
					type: 'get',
					contentType: 'application/json',
					success: function (data){
						var str = "<form>"
							str +="<table>"
							str += "<input value='"+data.id+"' type='hidden' class = 'form-control' id='productId'>"
							str += "<tr>"
							str += "<td style='text-align:end'>Product Initial  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.productInitial+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:right'>Category Name  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td> "+data.productName+"</td>"
							str += "</tr>"
							str += "<tr>"
							str += "<td style='text-align:end'>Active  </td>"
							str += "<td style='width: 10px;'></td>"
							str += "<td><input disabled checked type='checkbox'  id='isActive'></td>"
							str += "</tr>"
							str += "</table>"
							str += "</form>"
						
						$('#btn-save').html('Delete')
						$('#btn-save').removeClass().addClass('btn btn-danger')
						$('.modal-title').html('Delete')
						$('.modal-body').html(str)
						$('.modal-body').css("margin","auto")
						$('#btn-save').off('click').on('click',deletedata)
						$('#modal').modal('show')
					}
				})
			}
			function deletedata(){
				var id = $('#productId').val()
				$.ajax({
					url: '/api/delete/product/'+id+'',
					type: 'put',
					contentType:'application/json',
					success: function(){
						$('#modal').modal('toggle')
						getAllCategory()
					}					
				})
			}
		</script>
	</div>
</body>
</html>